/*Uzycie Assemblera w C++

Przykladowy program z pakietu
"Kurs podstaw Assemblera" by Grzegorz Zlotowicz <grzezlo@wanet.pl>
*/

/*Na poczatku musze zaznaczyc, iz program ten ma na celu jedynie
zademonstrowac uzycie Asm w C++. Oznacza to, ze kilka rzeczy moze byc
rozwiazane lamersko.*/

#include <stdio.h>
char g,m,s,sets; //Zadeklaruj bajty g,m,s

int gettime() //Pobierz czas z uzyciem int 21h/2ch
{
        asm         {// "{" musi byc w tej samej linii co asm
        mov ah,0x2c
        int 0x21
        mov g,ch // Mozemy przekazywac wartosci rejestrow do zmiennych
        mov m,cl
        mov s,dh
        mov sets,dl
}
return 0;
}

main()
{
        gettime();
        printf("Aktualny czas: %2d:%2d:%2d.%2d%s",g,m,s,sets,"\n");
        return g; //Zwrocimy dodatkowo godzine w errorlevel
}

/*Kilka wskazowek i uwag:
1. Skladnia:
asm
{
        ...
}
nie zadziala.
  2. Aby dokonac kompilacji programu ze wstawka Asm przy pomocy Turbo
c++ (testowalem pod 1.01), potrzebujesz tasm.exe i tlink.exe.

*/

