;Demonstracja instrukcji CMP i skoku warunkowego
;
;Wprowadza: CMP, JE, JNE, JA, JL, JNA, JNL
;
 ;Przykladowy program z pakietu
;"Kurs podstaw assemblera" by Grzegorz Zlotowicz
;
;Linie zaczynajace sie znakiem ; sa ignorowane przy kompilacji.
;
;
cseg segment
assume cs:cseg, ds:cseg, es:cseg
org 100h
start:
  jmp start2
oknap db 'Warunek spelniony ',13,10,'$'
OK:     ;Procedura wypisujaca napis o spelnieniu warunku
  push ax
  push dx       ;wrzucamy na stos rejestry, ktorych uzyjemy 
;w procedurze - mamy gwarancje, ze nie zakloci nam ona pracy programu glownego
  mov ah,09h
  mov dx,offset(oknap)
  int 21h

  pop dx
  pop ax        ;pobieramy ze stosu w odwrotnej kolejnosci
  ret

nook db 'Warunek nie zostal spelniony ',13,10,'$'
nok:
  push ax
  push dx
  mov ah,09
  mov dx,offset(nook)
  int 21h
  pop dx
  pop ax
  ret

start2:
  mov ax,1
  mov bx,1      ;ax=bx
  cmp ax,bx
  je war1
  call nok
  jmp wy

  war1:
  call ok
  mov ax,2      ;AX > BX
  cmp ax,bx
  ja war2       ;znowu warunek sie spelni
  call nok      ;gdyby jednak nie
  jmp wy

war2:
  call ok
  cmp ax,bx     ;porownujemy jeszcze raz, tym razem z innym warunkiem
                ;nadal wiemy, ze ax > bx
  jna war3      ;teraz sie nie spelni i nie przeskoczy
  call nok
  jmp wy

war3:
  call ok       ;nie udalo sie...
wy:
  mov ax,4c00h
  int 21h
cseg ends
end start

;Jak wiec zadziala nasz program po kompilacji?
;
;                               Powinien dwukrotnie wypisac komunikat o
;spelnieniu warunku, za trzecim razem - o niespelnieniu.
;
;OK, mysle, ze lapiesz istote sprawy - nie chcac sie bawic zbyt wiele
;a jednoczesnie nie zostawiajac tego - kilka przykladow CMP poza
;programem:
;cmp ah,1
;cmp ax,3
;cmp ax,4444H
;cmp al,ah
;cmp ah,al
;- czyli - jak widzisz - kombinacji jest sporo (a i tak nie wszystkie
;wypisalem:)).
;
;---
;Jesli masz jakies pytania/uwagi/propozycje,
;to nie zwlekaj  i pisz smialo:) na adres
;e-mail: grzezlo@wanet.pl
;Dzieki z gory!
;
;Z powazaniem - Grzegorz Zlotowicz

