;Wypisanie na ekran aktualnej daty i czasu
;Wersja poprawiona
;Usunieto glupie niedopatrzenie, ktore powodowalo, ze po 2 tysiecznym
;roku program wypisywal bzdury
;
;
 ;Przykladowy program z pakietu
;"Kurs podstaw assemblera" by Grzegorz Zlotowicz
;
;Linie zaczynajace sie znakiem ; sa ignorowane przy kompilacji.
;
;
cseg segment
assume cs:cseg, ds:cseg, es:cseg
org 100h
start:
                ;No to cos "powazniejszego", chociaz... a zreszta.
  jmp pocz      ;Skok do prawdziwego poczatku
                ;tutaj dane i procedury
crlf db 13,10,'$'       ;przejscie do nowej linii
jestdata db 'Dzisiaj jest $'
jestgodz db 'Jest godzina $'

pznak:          ;procedure piszznak - znak jest dany jako parametr w AL
                ;przyda sie kilka razy
    push ax
    push bx       ;zapamietac rejestry modyfikowane w procedurce
    mov ah,0eh
    mov bx,0
    int 10h       ;Int 10h/0eh - wypisanie znaku na ekran:
                ;Ah=0eh, Al=Ascii znaku do wypisania;
                ;Przerwanie nie zwraca nic.
;
                ;znak wypisany przywracamy AX i BX i nie ma nas!
    pop bx
    pop ax
  ret

pisznum:
                ;procedura wypisujaca dwucyfrowa liczbe ktora podajemy do procedury w
                ;AL; algorytm jest troche lamerski, ale do naszych celow starczy

                ;OK - najpierw zapamietajmy rejestry, ktore bedziemy zmieniac w
                ;procedurce coby nie namieszac
    push ax
    push bx     ;Ten algorytm zadziala dla AL <=99 - czyli dwoch cyfr.

                ;1. Dzielimy al przez 10, wypisujemy dziesiatki i jednosci
    xor ah,ah       ;Najprostszy sposob wyzerowania rejestru
                ;na wszelki wypadek
    mov bh,10
    div bh      ;ax podzielone zostalo przez bh
                ;teraz al zawiera iloraz ax/10 a ah - reszte.
    add al,'0'  ;dodaje do wartosci al kod ascii zera 
                ;tak, ze obecnie al zawiera kod
                ;ascii pierwszej cyfry w liczbie
                ;mozemy uzyc spoko procedury pznak
    call pznak  ;pierwsza cyfra wypisana
    mov al,ah   ;teraz al zawiera reszte z dzielenia, wypisujemy ja tez na ekran
    add al,'0'  ;praktycznie to samo co poprzednio
    call pznak  ;druga cyfra wypisana

    pop bx      ;wszystko zrobione, przywracamy rejestry
    pop ax      ;zmieniane w procedurze i...
  ret           ;wracamy do programu

piszdate:       ;wypisuje date
    mov ah,09h
    mov dx,offset(jestdata)
    int 21h     ;No to napis poszedl...
    mov ah,2ah  ;Int 21h/2ah - pobranie daty systemu
    int 21h     ;teraz: cx=rok, dh=miesiac, dl=dzien
                ;piszemy dzien
    mov al,dl
    call pisznum        ;jak to bylo powiedziane...
    mov al,'-'  ;piszemy myslnik
    call pznak  ;oplacalo sie zrobic procedurke - uzylismy ja juz kilka razy

    mov al,dh   ;piszemy miesiac
    call pisznum;tez sie oplacalo...
    mov al,'-'  ;piszemy nastepny myslnik
    call pznak

                ;no i zostaje rok, ale tu juz nie tak latwo:
                ;napisalismy procedurke dla dwoch cyfr a tu niespodzianka
                ;- trzeba
                ;wypisac rejestr dwubajtowy (rok jest w formacie 1980-2079), ale
                ;obejdziemy to bardzo prosto - odejmiemy 1900 od cx, i zostanie
                ;formacie 80-179 tzn. po dwutysiecznym roku zaczalby fiksowac, 
                ;ale nie zacznie:), gdyz odejmiemy 100 (179-100=79).
    sub cx,1900
    cmp cl,100
    jb przed2tys;porownujemy mlodszy bajt cl z wartoscia graniczna - 100.
                ;Jesli jest mniejsze od 100 to znaczy, ze jest przed 
                ;dwutysiecznym; jesli jest inaczej, to jest po dwutysiecznym
i najpierw
                ;wypiszemy '20' a pozniej cl-100, czyli
                ;np. 20 | 75 - oczywiscie bez |
                ;wyjdzie 2075.

    mov al,20   ;no to piszemy '20'
    call pisznum
    sub cl,100  ;odejmujemy 100 od cl
przed2tys:
    mov al,cl   ;piszemy dwie ostatnie cyfry roku
    call pisznum;bez wzgledu na wszystko...
    mov ah,09h  ;przejscie do nowej linii
    mov dx,offset(crlf)
    int 21h
  ret           ;i to juz koniec procedurki

piszczas:       ;Wypisuje aktualny czas
    mov ah,09h
    mov dx,offset(jestgodz)
    int 21h     ;wypisalismy napis
    mov ah,2ch  ;pobieramy czas
    int 21h     ;teraz: ch=godz, cl=min, dh=sek
    mov al,ch   ;piszemy godzine
call pisznum
    mov al,':'
    call pznak  ;tego nie trzeba wyjasniac mam nadzieje...?
    mov al,cl   ;minuta
    call pisznum
    mov al,':'
    call pznak
    mov al,dh   ;sekunda
    call pisznum
    mov ah,09h  ;znowu - do nowej linii
    mov dx,offset(crlf)
    int 21h
  ret

pocz:           ;Poczatek wlasciwy programu
  call piszdate
  call piszczas
  mov ax,4c00h  ;I to tyle - wychodzimy!
  int 21h
cseg ends
end start

;No to napisalismy calkiem przyzwoity i nawet dlugi program. Pytanie
;pierwsze - czy dziala - w tej kwestii przezylem przed chwila dwukrotny
;szok: 1. Kompiluje sie bez bledow! 2. Dziala tzn. pisze porzadnie date
;i czas - bez pluskiew:).
;
;
;
;
;---
;Jesli masz jakies pytania/uwagi/propozycje,
;to nie zwlekaj  i pisz smialo:) na adres
;e-mail: grzezlo@wanet.pl
;Dzieki z gory!
;
;Z powazaniem - Grzegorz Zlotowicz

