;Uruchomienie komendy DOS, lub programu przy uzyciu int2eh
;
 ;Przykladowy program z pakietu
;"Kurs podstaw assemblera" by Grzegorz Zlotowicz
;
;Linie zaczynajace sie znakiem ; sa ignorowane przy kompilacji.
cseg segment
assume cs:cseg, ds:cseg, es:cseg
org 100h
start:          ;Na poczatku musimy zwolnic mozliwie duzo pamieci,
                ;teraz zaalokowanej dla naszego programu, by moc
                ;uruchomic komende dos.
                ;Instrukcja realokacji pamieci to int21/4ah -
                ;zob. tabela przerwania int 21h.
;
                ;BX musi zawierac nowa dlugosc bloku w paragrafach 
                ;(blokach 16-bajtowych) +1.
  mov ax,offset(endprog) ;gdzie konczy sie nasz program
  xor dx,dx     ;wyzerowanie rejestru
  mov bx,10h
  div bx        ;dx:ax podzielone przez 16
  mov bx,ax     ; wynik do bx
  inc bx        ;bx - nowa dlugosc bloku+1 paragraf
  mov ah,4ah
  int 21h       ;pamiec zwolniona
                ;No to teraz przystepujemy do uruchomienia przerwania int2EH:
;:int 2e
;^INT 2E - Wykonaj komende uzywajac interpretera komend bazowego poziomu
;^(Nieudokumentowane DOS 2.0+)
;
;        DS:SI = wskaznik do lancucha z komenda do wykonania
;
;        przerwanie nie zwraca nic ???
;  - powoduje wykonanie komendy przez bazowy interpreter polecen, jakby
;zostala ona wpisana z klawiatury
;  - Usuwalna porcja command.com musi byc zaladowana, jesli nie
;rezyduje
;  - pierwszy bajt lancucha zawiera laczna dlugosc lancucha
;  - lancuch komendy musi byc zakonczony znakiem <cr> - #0DH
;  - wszystkie rejestry, wlacznie z SS i SP, sa niszczone; SS i SP
;powinny byc przechowane w programie
;  - moze byc uzyte do modyfikacji srodowiska, komenda set
;  - niekompatybilne z niektorymi programowymi multitaskerami

  mov oldss,ss  ;zgodnie ze wskazowkami - zachowamy SS i SP
  mov oldsp,sp
  mov si,offset(cmd)
  int 2eh       ;Komenda wykonana - pobierzmy SS i SP
  mov ss,oldss
  mov sp,oldsp

  mov ax,4c00h  ;wyjscie
  int 21h
cmd db 3,'dir',13
oldss dw ?
oldsp dw ?
endprog db 0

cseg ends
end start




;---
;Jesli masz jakies pytania/uwagi/propozycje,
;to nie zwlekaj  i pisz smialo:) na adres
;e-mail: grzezlo@wanet.pl
;Dzieki z gory!
;
;Z powazaniem - Grzegorz Zlotowicz


